$fn=100;

$vpt = [-29, -188, 206];
$vpr = [60, 0, 217];
$vpd =1756;

frame(0,0,0);



module joint()
{
    color("gray")
    difference()
    {
    union()
    {
        translate([0,-30,0])
        cube([2,32,40]);
        translate([-80,0,0])
        cube([80,2,40]);
    }
    translate([-10,0,7.5])
    rotate(a=90,v=[1,0,0])
    translate([0,0,-5])
    cylinder(r=2,h=10);
    
    translate([-30,0,7.5])
    rotate(a=90,v=[1,0,0])
    translate([0,0,-5])
    cylinder(r=2,h=10);
    
    translate([-50,0,7.5])
    rotate(a=90,v=[1,0,0])
    translate([0,0,-5])
    cylinder(r=2,h=10);
    
    translate([-70,0,7.5])
    rotate(a=90,v=[1,0,0])
    translate([0,0,-5])
    cylinder(r=2,h=10);
    
    translate([-10,0,7.5+25])
    rotate(a=90,v=[1,0,0])
    translate([0,0,-5])
    cylinder(r=2,h=10);
    
    translate([-30,0,7.5+25])
    rotate(a=90,v=[1,0,0])
    translate([0,0,-5])
    cylinder(r=2,h=10);
    
    translate([-50,0,7.5+25])
    rotate(a=90,v=[1,0,0])
    translate([0,0,-5])
    cylinder(r=2,h=10);
    
    translate([-70,0,7.5+25])
    rotate(a=90,v=[1,0,0])
    translate([0,0,-5])
    cylinder(r=2,h=10);
    
    translate([0,-5,7.5+25])
    rotate(a=90,v=[0,1,0])
    translate([0,0,-5])
    cylinder(r=2,h=10);
    
    translate([0,-5-20,7.5+25])
    rotate(a=90,v=[0,1,0])
    translate([0,0,-5])
    cylinder(r=2,h=10);
    
    translate([0,-5,7.5])
    rotate(a=90,v=[0,1,0])
    translate([0,0,-5])
    cylinder(r=2,h=10);
    
    translate([0,-5-20,7.5])
    rotate(a=90,v=[0,1,0])
    translate([0,0,-5])
    cylinder(r=2,h=10);
    
    } 
}



module frame(x,y,z)
{
    
    translate([x,y,z])
    rotate(a=-90,v=[0,0,1])
    {
        //frame horizontal
        color("lightgray")
        rotate(a=90,v=[1,0,0])
        translate([10,20,-140])
        rounded_cube(20,40,280,1.5);
       
        color("lightgray")
        rotate(a=90,v=[1,0,0])
        translate([390,20,-140])
        rounded_cube(20,40,280,1.5);

        color("lightgray")
        rotate(a=90,v=[0,0,1])
        rotate(a=90,v=[1,0,0])
        translate([-140,20,0])
        rounded_cube(20,40,400,1.5);

        color("lightgray")
        rotate(a=90,v=[0,0,1])
        rotate(a=90,v=[1,0,0])
        translate([140,20,0])
        rounded_cube(20,40,400,1.5);

        //freme vertical
        color("lightgray")
        translate([320,-0+140+20,0])
        rounded_cube(40,20,400,1.5);
        
        color("lightgray")
        translate([320,-0-140-20,0])
        rounded_cube(40,20,400,1.5);
        
        color("lightgray")
        rotate(a=90,v=[1,0,0])
        translate([320,390,-160])
        rounded_cube(40,20,320,1.5);

        //spool mount
        color("lightgray")
        translate([320,0,365])
        cylinder(r=4,h=150);
        
        color("gray")
        {
            translate([300,+146,110])
            {
                cube([40,4,20]);
                translate([0,-30,0])
                cube([4,30,20]);
            }
            translate([300,-150,110])
            {
                cube([40,4,20]);
                translate([0,4,0])
                cube([4,30,20]);
            }
        }
        color("white")
        {
            translate([15,-150+15,-15])
            //cube([30,30,15]);
            rounded_cube(30,30,15,2);
            translate([15,+120+15,-15])
            rounded_cube(30,30,15,2);     
            translate([370+15,-150+15,-15])
            rounded_cube(30,30,15,2);
            translate([370+15,+120+15,-15])
            rounded_cube(30,30,15,2); 
        }  
       

        rotate(a=90,v=[0,0,1])
        {
            translate([150,0,0])
            joint();
            translate([-150,0,0])
            mirror([1,0,0])
            joint();

            translate([150,-400,0])
            mirror([0,1,0])
            joint();
            translate([-150,-400,0])
            mirror([0,1,0])
            mirror([1,0,0])
            joint(); 
            
            translate([-170,-300,400])
            rotate(a=90,v=[0,0,1])
            rotate(a=-90,v=[0,1,0])
            joint();

            translate([170,-300,400])
            rotate(a=90,v=[0,0,1])
            mirror([0,1,0])
            rotate(a=-90,v=[0,1,0])
            joint();
        }
    }

}

module rounded_cube( x, y, z, r)
{
    translate([-x/2+r,-y/2+r,0])
    linear_extrude(height=z)
    minkowski() 
    {
        square([x-2*r,y-2*r],true);
        translate([x/2-r,y/2-r,0])
        circle(r);

    }
}