$fn=100;
difference()
{
    union()
    {
    translate([-w/2-wt,-5,-7])
    cube([4,10,10]);
    rotate(a=90,v=[0,1,0])
    translate([7,0,-w/2-wt])
    cylinder(r=5,h=4);
    }
    rotate(a=90,v=[0,1,0])
    translate([7,0,-w/2-wt-1])
    cylinder(r=1.6,h=6);

    rotate(a=90,v=[0,1,0])
    translate([7,0,-w/2-1])
    cylinder(r=3.5,h=3);
}

//BOX
//-------------------------------
//inner box width + tolerances
w=68.4;
//inner box height + tolerances
h=41;
//inner box depth 
d=40;
//wall tickness
wt=3;
//slits size
s=2.2;
//-------------------------------
//POWER CONNECTOR
//-------------------------------
//position
cx=0;
cy=0;
//width
cw=27;
//height
ch=18.5;
//holes size (radius)
chs=2;
//holes distance
chd=40;
//-------------------------------
//POWER SWITCH
//-------------------------------
//position
sx=0;
sy=0;
//width
sw=0;
//height
sh=0;
//-------------------------------
//SIDE HOLDERS
//-------------------------------
//position
shy=10;
shz=10;
//tickness
sht=5;
//diameter
shd=15;
//hole size
shhs_inner=2;
shhs_outer=3.5;
//cutout
coz=5;
//-------------------------------
//-------------------------------

// side holder left

translate([-w/2+sht/2+s,h/2+0.005,d+wt-shz])
rotate(a=90,v=[0,1,0])
difference()
{
    translate([0,0,-sht/2])
    cylinder(r=shd,h=sht);
    
    translate([0,shd+1,0])
    cube([shd*2+2,shd*2+2,sht+2],true);
    
    translate([+0,-shy,+sht/2-0.2])
    fhex(5.5,sht/2);
    
    translate([0,-shy,-sht/2-1])
    cylinder(r=shhs_inner,h=sht+2);
    
    translate([-shz-10+coz,-h/2,+w/2-sht/2-s])
    cube([20,h,w+10],true);
} 


// side holder right

translate([w/2-sht/2-s,h/2+0.005,d+wt-shz])
rotate(a=90,v=[0,1,0])
difference()
{
    translate([0,0,-sht/2])
    cylinder(r=shd,h=sht);
    
    translate([0,shd+1,0])
    cube([shd*2+2,shd*2+2,sht+2],true);
    
    translate([+0,-shy,-sht/2+0.2])
    fhex(5.5,sht/2);
    
    translate([0,-shy,-sht/2-1])
    cylinder(r=shhs_inner,h=sht+2); 
    
    translate([-shz-10+coz,-h/2,-w/2+sht/2+s])
    cube([20,h,w+10],true); 
}
         
    
difference()
{
    rounded_cube( w+2*wt, h+2*wt, d+wt, 5);
    union()
    {
     
        translate([ -w/2, -h/2, wt])
        cube([w,h,d+wt]);

        //holes
        translate([0,h/2-shy,d+wt-shz])
        rotate(a=90,v=[0,1,0])
        translate([0,0,-(w+2*wt)/2-1])
        cylinder(r=shhs_inner,h=w+2*wt+2);
                
        translate([(w/2+wt+1.5)-2,h/2-shy,d+wt-shz])
        rotate(a=90,v=[0,1,0])
        translate([0,0,-1.5])
        cylinder(r=shhs_outer,h=3);
        
        translate([-(w/2+wt+1.5)+2,h/2-shy,d+wt-shz])
        rotate(a=90,v=[0,1,0])
        translate([0,0,-1.5])
        cylinder(r=shhs_outer,h=3);
        
        //power connector cutout
        translate([cx,cy,0])
        {  
            translate([-cw/2,-ch/2,-1])
            cube([cw,ch,wt+2]); 
            translate([-chd/2,0,-1])
            cylinder(r=chs,h=wt+2);
            translate([+chd/2,0,-1])
            cylinder(r=chs,h=wt+2);
            
            translate([-chd/2,0,wt-1.25])
            fhex(5.5,3);
            translate([+chd/2,0,wt-1.25])
            fhex(5.5,3);
        }
        //power switch cutout
        translate([sx,sy,0])
        {  
            translate([ -sw/2, -sh/2, -1])
            cube([sw,sh,wt+2]); 
        }
    }

}
module rounded_cube( x, y, z, r)
{
    translate([-x/2+r,-y/2+r,0])
    linear_extrude(height=z)
    minkowski() 
    {

        square([x-2*r,y-2*r],true);
        translate([x/2-r,y/2-r,0])
        circle(r);

    }
}
module fhex(wid,height)
{
    hull()
    {
        cube([wid/1.7,wid,height],center = true);
        rotate([0,0,120])cube([wid/1.7,wid,height],center = true);
        rotate([0,0,240])cube([wid/1.7,wid,height],center = true);
    }
}
