use <limit_switch_model.scad>;

$fn=100;
sk8_double_x_with_nut(60,0,0);
sk8_double_x_with_nut_with_switch(-60,0,0);
limit_switch_model(-25-60,32,28);

module sk8_double_x_with_nut_with_switch(x,y,z)
{
    translate([x,y,z])
    {
        difference()
        {
        mirror([1,0,0])
        sk8_double_x_with_nut(0,0,0);
        color([0.2,0.2,0.2])    
        translate([5,31,30])
        rotate(a=-90,v=[0,1,0])
        cylinder(r=2,h=30);

        }
            //limit_switch(-70,21,20);
        limit_switch_cover(-0,21,20);
    }
}



module sk8_double_x_with_nut(x,y,z)
{
   translate([x,y,z])
   { 
       
    color([0.2,0.2,0.2])
    difference()
    {
        translate([3,0,17])
        {
            sk8_double_x(0,0,0);
            translate([-28,-40,-17])
            cube([45,80,20]);
        }


        translate([10,60,10])
        rotate(a=90,v=[1,0,0])
        cylinder(r=4.2,h=120);

        translate([-15,60,10])
        rotate(a=90,v=[1,0,0])
        cylinder(r=4.2,h=120);
        
        
        translate([10+0,-40+24+3.2,10])
        rotate(a=90,v=[1,0,0])
        cylinder(r=7.55,h=24+4);

        translate([10+0,40-3.2+4,10])
        rotate(a=90,v=[1,0,0])
        cylinder(r=7.55,h=24+4);
     
        translate([10,-15,20])
        cylinder(r=2.1,h=20);

        translate([10,-15,-1])
        cylinder(r=3.5,h=22);

        translate([10,+15,20])
        cylinder(r=2.1,h=22);

        translate([10,+15,-1])
        cylinder(r=3.5,h=22);
     
     
        // nut place
        translate([-15,49-12-2,10])
        rotate(a=-90,v=[1,0,0])
        rotate(a=45,v=[0,0,1])
        {
            translate([8,0,-15])
            cylinder(r=1.7,h=30);
            translate([-8,0,-15])
            cylinder(r=1.7,h=30);
            translate([0,8,-15])
            cylinder(r=1.7,h=30);
            translate([0,-8,-15])
            cylinder(r=1.7,h=30);
            translate([0,0,-10.5])
            cylinder(r=5.05,h=16);
            translate([0,0,0])
            cylinder(r=11.16,h=3.6+2);
            
            translate([-5,5,0])
            cylinder(r=11.16,h=3.6+2);
            
            translate([-8,0,-13])
            fhex(5.5,3);
            
            translate([8,0,-13])
            fhex(5.5,3);
            
            translate([0,-8,-13])
            fhex(5.5,3);
            
            translate([0,8,-13])
            fhex(5.5,3);
        }
        
        // edge cutting
        translate([-26,-72-2,-5])
        cube([26,95,30]);
        translate([-30,40,-2])
        cube([60,20,60]);
        translate([-30,-60,-2])
        cube([60,20,60]);
        
        
        //
        translate([10,-40+1.5+1.5,10])
        rotate(a=90,v=[1,0,0])
        cylinder(r=8.5,h=1.5);

        translate([20-8.5,-40+1.5,1.5])
        cube([9,1.5,17]);



        translate([10,+40-1.5,10])
        rotate(a=90,v=[1,0,0])
        cylinder(r=8.5,h=1.5);

        translate([20-8.5,+40-1.5-1.5,1.5])
        cube([9,1.5,17]);
        
    }
}
    
}


module sk8_double_x(x,y,z)
{
translate([x,y,z])
color([0.2,0.2,0.2])
translate([0,0,3])
rotate(a=90,v=[0,1,0])
rotate(a=90,v=[0,0,1])
{
    translate([-12-18+40,0,0])
    {
       import("..\\stl\\nonprintable\\SK08_-_M4.stl");

    }
    translate([-12-40,0,0])
    {
        translate([42,0,0])
        mirror([1,0,0])
        import("..\\stl\\nonprintable\\SK08_-_M4.stl"); 


    }
    difference()
    {
    translate([-12-40,-3,0])
    cube([104,3,17]);
        translate([-12-40,0,0])
        {
            translate([5,5,7])
            rotate(a=90,v=[1,0,0])
            cylinder(r=2.1,h=15);
            translate([37,5,7])
            rotate(a=90,v=[1,0,0])
            cylinder(r=2.1,h=15);
        }
        translate([-12-18+40,0,0])
        {

            translate([5,5,7])
            rotate(a=90,v=[1,0,0])
            cylinder(r=2.1,h=15);
            translate([37,5,7])
            rotate(a=90,v=[1,0,0])
            cylinder(r=2.1,h=15);
        }
    }
    //
    translate([0,0,-47])
    difference()
    {
    translate([0,0,50])
    {
        translate([-12-18+40,0,0])
        {
            import("..\\common\\SK08_-_M4.stl");
        }
        translate([-12-40,0,0])
        {
            translate([42,0])  
            mirror([1,0,0])
            import("..\\common\\SK08_-_M4.stl");

        }
    }
    translate([-12-51.5-4+0,-5,40])
    cube([140,50,20]);
    }
    //
    translate([0,0,61])
    mirror([0,0,1])
    difference()
    {
        translate([0,0,50])
        {
            translate([-12-18+40,0,0])
            {
                import("..\\common\\SK08_-_M4.stl");
            }
            translate([-12-40,0,0])
            {
                translate([42,0])  
                mirror([1,0,0])
                import("..\\common\\SK08_-_M4.stl");

            }
        }
        translate([-12-51.5-4+0,-5,40])
        cube([140,50,20]);
    }
}
}

module fhex(wid,height){
hull(){
cube([wid/1.7,wid,height],center = true);
rotate([0,0,120])cube([wid/1.7,wid,height],center = true);
rotate([0,0,240])cube([wid/1.7,wid,height],center = true);
}
}
