
use <openscad\idler_mount_x.scad>;
use <openscad\rods_8mm.scad>
use <openscad\belt_6mm.scad>
use <openscad\limit_switch_model.scad>


$vpt = [48, -40, -10];
$vpr = [69, 0, 209];
$vpd =756;

x_axis(0,0,0,175,100);

module x_axis(x,y,z,d,xpos)
{
    translate([x,y,z])
    translate([0,0,0])
    rotate(a=180,v=[0,0,1])
    rotate(a=90,v=[1,0,0])
    {
        belt_6mm(2*d+10,-33.5,0,36.5);
        rods_8mm(62,2*d+30,-d-15,0,40);
       
        translate([d-6,0,0])
        {
            color([0.2,0.2,0.2])
            translate([41,0,9])
            rotate(a=-90,v=[0,1,0])
            import("stl\\printable\\nut_M5.stl");
            color([0.2,0.2,0.2])
            import("stl\\printable\\sk8_double_x_with_nut.stl");
               
            color([0,0.8,0]) 
            translate([20,0,17])
            rotate(a=180,v=[0,0,1])
            import("stl\\printable\\idler_base_mount_x.stl");

            translate([20,0,16])
            rotate(a=180,v=[0,0,1])
            idler_mount_x(0,0,0,1);
            
            color([0,0.8,0])
            translate([10,25,10])
            rotate(a=-90,v=[1,0,0])
            {
             
                import("stl\\printable\\lmu815_156.stl");
                translate([11,-17,12])
                rotate(a=90,v=[0,0,1])
                import("stl\\printable\\slip_ring_xy.stl");
             }
             
            color([0,0.8,0])
            translate([10,25-50,10])
            rotate(a=-90,v=[1,0,0])
            {
            
                import("stl\\printable\\lmu815_154.stl");
                translate([11,-17,12-25])
                rotate(a=90,v=[0,0,1])
                import("stl\\printable\\slip_ring_xy.stl");
             }
            
        }

        translate([-d+6,0,0])
        {
            nema_with_puley(-48,0,29.5);
            color([0.2,0.2,0.2])
            mirror([1,0,0])
                
            import("stl\\printable\\sk8_double_x_with_nut.stl");
                
            color([0,0.8,0])
            translate([-20,0,17])
            rotate(a=180,v=[0,0,1])   
            import("stl\\printable\\motor_mount_x.stl");
            

            limit_switch(0,21,20);
            
            color([0,0.8,0])
            translate([-10,25,10])
            rotate(a=-90,v=[1,0,0])
            {
                import("stl\\printable\\lmu815_154.stl");
                translate([-11,17,12])
                rotate(a=-90,v=[0,0,1])
                import("stl\\printable\\slip_ring_xy.stl");
             }
             
            color([0,0.8,0])
            translate([-10,25-50,10])
            rotate(a=-90,v=[1,0,0])
            {
                import("stl\\printable\\lmu815_154.stl");
                translate([-11,17,12-25])
                rotate(a=-90,v=[0,0,1])
                import("stl\\printable\\slip_ring_xy.stl");
             }
            
        }
        translate([xpos-115,0,50])
        {      
            color([0.2,0.2,0.2])
            import("stl\\printable\\x_mount.stl");
            translate([-4,-18,5])
            color([0,0.8,0])
            scale([4.5,4.5,1.4])
            import("stl\\printable\\logo_25x25.stl");
            
            translate([0,0,0])
            {
                translate([38,14,0])
                rotate(a=90,v=[0,0,1])
                rotate(a=-90,v=[1,0,0])
                {
                    color([0.2,0.2,0.2])
                    import("stl\\printable\\sc8uu_edit.stl");
                    color([0,0.8,0])
                    {
                    translate([17,11,15])    
                    import("stl\\printable\\lmu815_156.stl");
                    translate([0,0,1.5])
                    import("stl\\printable\\slip_ring_xy.stl");
                    translate([0,0,1.5+25.5])
                    import("stl\\printable\\slip_ring_xy.stl");
                    }
                }

                translate([-7,14,0])
                rotate(a=90,v=[0,0,1])
                rotate(a=-90,v=[1,0,0])
                {
                    color([0.2,0.2,0.2])
                    import("stl\\printable\\sc8uu_edit.stl");
                    color([0,0.8,0])
                    {
                    translate([17,11,15])    
                    import("stl\\printable\\lmu815_156.stl");
                    translate([0,0,1.5])
                    import("stl\\printable\\slip_ring_xy.stl");
                    translate([0,0,1.5+25.5])
                    import("stl\\printable\\slip_ring_xy.stl");
                    }
                }

                translate([38,-62+14,0])
                rotate(a=90,v=[0,0,1])
                rotate(a=-90,v=[1,0,0])
                {
                    color([0.2,0.2,0.2])
                    import("stl\\printable\\sc8uu_edit.stl");
                    color([0,0.8,0])
                    {
                    translate([17,11,15])    
                    import("stl\\printable\\lmu815_156.stl");
                    translate([0,0,1.5])
                    import("stl\\printable\\slip_ring_xy.stl");
                    translate([0,0,1.5+25.5])
                    import("stl\\printable\\slip_ring_xy.stl");
                    }
                }
                
                translate([-7,-62+14,0])
                rotate(a=90,v=[0,0,1])
                rotate(a=-90,v=[1,0,0])
                {
                    color([0.2,0.2,0.2])
                    import("stl\\printable\\sc8uu_edit.stl");
                    color([0,0.8,0])
                    {
                    translate([17,11,15])    
                    import("stl\\printable\\lmu815_156.stl");
                    translate([0,0,1.5])
                    import("stl\\printable\\slip_ring_xy.stl");
                    translate([0,0,1.5+25.5])
                    import("stl\\printable\\slip_ring_xy.stl");
                    }
                }
            }
        }

    }
}
module nema_with_puley(x,y,z)
{
    translate([x,y,z])
    {
        color("lightgray")
        translate([4,0,1])
        rotate(a=-90,v=[0,0,1])
        import("stl\\nonprintable\\GT2_16T_Pulley_for_Alu_CNC.stl");
        color([0.2,0.2,0.2])
        scale([1,1,0.9])
        import("stl\\nonprintable\\Nema17.stl");
    }
}
module rounded_square( width, radius_corner ) 
{
	translate( [ radius_corner, radius_corner, 0 ] )
    minkowski() 
    {
			square( width - 2 * radius_corner );
			circle( radius_corner );
	}
}



module fhex(wid,height){
hull(){
cube([wid/1.7,wid,height],center = true);
rotate([0,0,120])cube([wid/1.7,wid,height],center = true);
rotate([0,0,240])cube([wid/1.7,wid,height],center = true);
}
}


