
$fn=100;

y_mount_arm(0,0,0);
mirror([1,0,0])
y_mount_arm(0,0,0);
mirror([0,1,0])
y_mount_arm(0,0,0);
mirror([1,1,0])
y_mount_arm(0,0,0);

y_mount_base(0,0,0);



module y_mount_arm(x,y,z)
{
    color([0,0.8,0])
    translate([x,y,z])
    {
        difference()
        {

            union()
            {    
                translate([74,74,4])
                rotate(a=45,v=[0,0,1])
                cube([91,60,8],center=true);
                translate([104.5,104.5,-4])  
                cylinder(r=10, h=12);   
                translate([40.55-20+3,40.55-20+3,0])
                cube([42.55,42.55,8]);
            }
            translate([111.6,45,4])
            rotate(a=55,v=[0,0,1])
            cube([120,60,10],center=true);

            translate([49.1,114.5,4])
            rotate(a=35,v=[0,0,1])
            cube([120,60,10],center=true);
              
            translate([104.5,104.5,4]) 
            cylinder(r=7, h=9);
            translate([104.5,104.5,-5]) 
            cylinder(r=2, h=10);
            
            translate([40.5-36.5,40.5-36.5,-1])
            cube([45-2.5,45-2.5,10]);
            
            translate([10,10,4])
            linear_extrude(height=5)
            rounded_square(50,5);

            lezaj(44.35,42.35,-4);

        }
        
        translate([104.5,104.5,-4])
        difference()
        {
            cylinder(r=10, h=12);
            translate([0,0,-5])
            cylinder(r=2, h=14);
            translate([0,0,4])
            cylinder(r=7, h=9);
        }
    }
}


module rounded_square( width, radius_corner ) 
{
	translate( [ radius_corner, radius_corner, 0 ] )
    minkowski() 
    {
			square( width - 2 * radius_corner );
			circle( radius_corner );
	}
}

module fhex(wid,height){
hull(){
cube([wid/1.7,wid,height],center = true);
rotate([0,0,120])cube([wid/1.7,wid,height],center = true);
rotate([0,0,240])cube([wid/1.7,wid,height],center = true);
}
}


module lezaj(x,y,z)
{
    translate([x,y,0])
    {
        translate([-9,12,-5])
        cylinder(r=2.5,h=20);
        translate([-9,12,8+z])
        cylinder(r=4.5,h=20);
        
        translate([-9,-12,-5])
        cylinder(r=2.5,h=20);
        translate([-9,-12,8+z])
        cylinder(r=4.5,h=20);
        
        translate([9,12,-5])
        cylinder(r=2.5,h=20);
        translate([9,12,8+z])
        cylinder(r=4.5,h=20);
        
        translate([9,-12,-5])
        cylinder(r=2.5,h=20);
        translate([9,-12,8+z])
        cylinder(r=4.5,h=20);
        

        
    }
}

module y_mount_base(x,y,z)
{
    /*translate([0,0,8])
    rotate(a=180,v=[1,0,0])*/
    color([0.2,0.2,0.2])
    translate([x,y,z])
    {
    difference()
    {
        translate([-60,-60,0])
        linear_extrude(height=8)
        rounded_square(120,5);
        lezaj(44.35,42.35,-1.5);
        lezaj(44.35,-42.35,-1.5);
        lezaj(-44.35,42.35,-1.5);
        lezaj(-44.35,-42.35,-1.5);

        
        translate([-42,0,-8])    
        cylinder(r=3.65,h=10);

        translate([42,0,-8])
        cylinder(r=3.65,h=10);
        
        translate([-0,-42,-8])
        cylinder(r=3.65,h=10);

        translate([0,42,-8])
        cylinder(r=3.65,h=10);
        
        translate([-42,0,0])    
        cylinder(r=2.2,10);

        translate([42,0,0])
        cylinder(r=2.2,10);

        translate([0,-42,0])
        cylinder(r=2.2,10);

        translate([0,42,0])
        cylinder(r=2.2,10);
        
        
        difference()
        {
            translate([40.55-20+3,40.55-20+3,-1])
            cube([42.55,42.55,5]);
            translate([40.5-36.5,40.5-36.5,-2])
            cube([45-2.5,45-2.5,7]);
        }
        
        mirror([1,0,0])
        difference()
        {
            translate([40.55-20+3,40.55-20+3,-1])
            cube([42.55,42.55,5]);
            translate([40.5-36.5,40.5-36.5,-2])
            cube([45-2.5,45-2.5,7]);
        }
        mirror([0,1,0])
        {
            difference()
            {
                translate([40.55-20+3,40.55-20+3,-1])
                cube([42.55,42.55,5]);
                translate([40.5-36.5,40.5-36.5,-2])
                cube([45-2.5,45-2.5,7]);
            }
            
            mirror([1,0,0])
            difference()
            {
                translate([40.55-20+3,40.55-20+3,-1])
                cube([42.55,42.55,5]);
                translate([40.5-36.5,40.5-36.5,-2])
                cube([45-2.5,45-2.5,7]);
            }
        }
        
        

    }
    translate([0,1,0])
    {
    translate([0,-16,3])
    difference()
    {
        translate([5,-4,-10])
        cube([10,10,10]);

        translate([4,-3,-20])
        rotate(a=45,v=[1,0,0])
        cube([12,15,15]);
    }
    translate([-20,-16,3])
    difference()
    {
        translate([5,-4,-10])
        cube([10,10,10]);

        translate([4,-3,-20])
        rotate(a=45,v=[1,0,0])
        cube([12,15,15]);
    }
    translate([0,0,3])
    difference()
    {
        translate([5,-4,-10])
        cube([10,10,10]);

        translate([4,5,-20])
        rotate(a=45,v=[1,0,0])
        cube([12,15,15]);
    }
    translate([-20,0,3])
    difference()
    {
        translate([5,-4,-10])
        cube([10,10,10]);

        translate([4,5,-20])
        rotate(a=45,v=[1,0,0])
        cube([12,15,15]);
    }

    difference()
    {
        union()
        {
            translate([-15,-4,-30])
            rotate(a=90,v=[1,0,0])
            linear_extrude(height=6)
            rounded_square(30,5);
            translate([-15,-3-7,-20])
            cube([30,6,20]);
        }

        translate([-4,-4+2,-25])
        rotate(a=90,v=[1,0,0])
        linear_extrude(height=10)
        rounded_square(8,3);
        translate([-4,-4+2,-22])
        rotate(a=90,v=[1,0,0])
        linear_extrude(height=10)
        rounded_square(8,3);
        translate([-4,-4+2,-19])
        rotate(a=90,v=[1,0,0])
        linear_extrude(height=10)
        rounded_square(8,3);
        translate([-4,-4+2,-16])
        rotate(a=90,v=[1,0,0])
        linear_extrude(height=10)
        rounded_square(8,3);
        translate([-4,-4+2,-13])
        rotate(a=90,v=[1,0,0])
        linear_extrude(height=10)
        rounded_square(8,3);
    }
    }
    }
}





