use <openscad\rods_8mm.scad>
use <openscad\belt_6mm.scad>
use <openscad\idler_mount_y.scad>
use <openscad\limit_switch_model.scad>
use <openscad\print_bed.scad>


$vpt = [0, 7, -50];
$vpr = [45, 0, 237];
$vpd =933;


y_axis(0,0,0,200,100);


module y_axis(x,y,z,d,ypos)
{
    translate([x,y,z])
    rotate(a=-90,v=[0,0,1])
    {   
        belt_6mm(2*d-10,30,0,-13);
        rods_8mm(85,2*d,-d,-0.5,-11);
      
        translate([-d,-0.5,-24])
        {
            color([0,0.8,0])
            import("stl\\printable\\idler_base_mount_y.stl");
            idler_mount_y(-5,0,-8,1);
            color([0.2,0.2,0.2])
            translate([-22,0,44])
            rotate(a=90,v=[0,1,0])
            import("stl\\printable\\nut_M5.stl");
            
            limit_switch(20,33,-6);
            translate([3,0,0])
            color([0.2,0.2,0.2])
            import("stl\\printable\\sk8_double_y_low.stl");
        }
        translate([d,-0.5,-24])
        {
            nema_with_puley(20,0.5,5);
            color([0,0.8,0])
            import("stl\\printable\\motor_mount_y.stl");

            translate([-17,0,0])
            color([0.2,0.2,0.2])
            import("stl\\printable\\sk8_double_y_low.stl");
        }
        translate([-115+ypos,0,0])
        {
            color([0.2,0.2,0.2])
            import("stl\\printable\\y_mount_base.stl");
            color([0,0.8,0])
            {
            import("stl\\printable\\y_mount_arm.stl");
            mirror([1,0,0])
            import("stl\\printable\\y_mount_arm.stl");
            mirror([0,1,0])
            import("stl\\printable\\y_mount_arm.stl");
            mirror([0,1,0])
            mirror([1,0,0])
            import("stl\\printable\\y_mount_arm.stl");
            }
            print_bed(0,0,25);
            translate([-35,10,29])
            color([0,0.8,0])
            scale([10,10,1.4])
            rotate(a=-90,v=[0,0,1])
            import("stl\\printable\\logo_25x25.stl");
                    
            translate([104.5,104.5,-10])
            {
                color("lightgray")
                cylinder(r=2,h=40);
                color("black")
                translate([0,0,-5])
                import("stl\\printable\\nut_M4.stl");
            }
            translate([104.5,-104.5,-10])
            {
                color("lightgray")
                cylinder(r=2,h=40);
                color("black")
                translate([0,0,-5])
                import("stl\\printable\\nut_M4.stl");
            }
            translate([-104.5,104.5,-10])
            {
                color("lightgray")
                cylinder(r=2,h=40);
                color("black")
                translate([0,0,-5])
                import("stl\\printable\\nut_M4.stl");
            }
            translate([-104.5,-104.5,-10])
            {
                color("lightgray")
                cylinder(r=2,h=40);
                color("black")
                translate([0,0,-5])
                import("stl\\printable\\nut_M4.stl");    
            }

                translate([60,25,0])
                rotate(a=90,v=[0,0,1])
                rotate(a=-90,v=[1,0,0])
                {
                    color([0.2,0.2,0.2])
                    import("stl\\printable\\sc8uu_edit.stl");
                    color([0,0.8,0])
                    {
                    translate([17,11,15])    
                    import("stl\\printable\\lmu815_156.stl");
                    translate([0,0,1.5])
                    import("stl\\printable\\slip_ring_xy.stl");
                    translate([0,0,1.5+25.5])
                    import("stl\\printable\\slip_ring_xy.stl");
                    }
                }

                translate([-29,25,0])
                rotate(a=90,v=[0,0,1])
                rotate(a=-90,v=[1,0,0])
                {
                    color([0.2,0.2,0.2])
                    import("stl\\printable\\sc8uu_edit.stl");
                    color([0,0.8,0])
                    {
                    translate([17,11,15])     
                    import("stl\\printable\\lmu815_156.stl");
                    translate([0,0,1.5])
                    import("stl\\printable\\slip_ring_xy.stl");
                    translate([0,0,1.5+25.5])
                    import("stl\\printable\\slip_ring_xy.stl");
                    }
                }

                translate([60,-60,0])
                rotate(a=90,v=[0,0,1])
                rotate(a=-90,v=[1,0,0])
                {
                    color([0.2,0.2,0.2])
                    import("stl\\printable\\sc8uu_edit.stl");
                    color([0,0.8,0])
                    {
                    translate([17,11,15])    
                    import("stl\\printable\\lmu815_156.stl");
                    translate([0,0,1.5])
                    import("stl\\printable\\slip_ring_xy.stl");
                    translate([0,0,1.5+25.5])
                    import("stl\\printable\\slip_ring_xy.stl");
                    }
                }

                translate([-29,-60,0])
                rotate(a=90,v=[0,0,1])
                rotate(a=-90,v=[1,0,0])
                {
                    color([0.2,0.2,0.2])
                    import("stl\\printable\\sc8uu_edit.stl");
                    color([0,0.8,0])
                    {
                    translate([17,11,15])    
                    import("stl\\printable\\lmu815_156.stl");
                    translate([0,0,1.5])
                    import("stl\\printable\\slip_ring_xy.stl");
                    translate([0,0,1.5+25.5])
                    import("stl\\printable\\slip_ring_xy.stl");
                    }
                }
            }
     }
}

module nema_with_puley(x,y,z)
{
    translate([x,y,z])
    {
        color("lightgray")
        translate([4,0,1])
        rotate(a=-90,v=[0,0,1])
        import("stl\\nonprintable\\GT2_16T_Pulley_for_Alu_CNC.stl");
        color([0.2,0.2,0.2])
        scale([1,1,0.9])
        import("stl\\nonprintable\\Nema17.stl");
    }
}