
$fn=100;
belt_z(0,0,0);
module belt_z(x,y,z)
{
    translate([x,y,z])
    {
        t_step = 0.05;
        width = 2;


        p1 = [-33, -10];
        p2 = [-6, 90];
        p3 = [6, 90];
        p4 = [33, -10];

        p5 = [-40, -30];
        p6 = [-60, -30];
        p7 = [-80, -25];

        p8 = [40, -30];
        p9 = [60, -30];
        p10 = [80, -25];

        p11 = [160+18, 20];
        p12 = [160+18, -55];
        p13 = [140, 30-25-55];

        p14 = [-160-18, 20];
        p15 = [-160-18, -55];
        p16 = [-140, 30-25-55];


        points1 = bezier_curve(t_step, p1, p2, p3, p4);
        points2 = bezier_curve(t_step, p1, p5, p6, p7);
        points3 = bezier_curve(t_step, p4, p8, p9, p10);
        points4 = bezier_curve(t_step, p10, p11, p12, p13);
        points5 = bezier_curve(t_step, p7, p14, p15, p16);
        translate([-5,80,0])
        color([0.2,0.2,0.2])
        translate([5,-15,-3.5])
        linear_extrude(height=6)
        {
            
        polyline(points1, width);
        polyline(points2, width);
        polyline(points3, width);
        polyline(points4, width);
        polyline(points5, width);
        line(p13,p16);
        }
    }
}


function bezier_coordinate(t, n0, n1, n2, n3) = 
    n0 * pow((1 - t), 3) + 3 * n1 * t * pow((1 - t), 2) + 
        3 * n2 * pow(t, 2) * (1 - t) + n3 * pow(t, 3);

function bezier_point(t, p0, p1, p2, p3) = 
    [
        bezier_coordinate(t, p0[0], p1[0], p2[0], p3[0]),
        bezier_coordinate(t, p0[1], p1[1], p2[1], p3[1]),
        bezier_coordinate(t, p0[2], p1[2], p2[2], p3[2])
    ];


function bezier_curve(t_step, p0, p1, p2, p3) = 
    [for(t = [0: t_step: 1 + t_step]) bezier_point(t, p0, p1, p2, p3)];


module line(point1, point2, width = 1, cap_round = true) {
    angle = 90 - atan((point2[1] - point1[1]) / (point2[0] - point1[0]));
    offset_x = 0.5 * width * cos(angle);
    offset_y = 0.5 * width * sin(angle);

    offset1 = [-offset_x, offset_y];
    offset2 = [offset_x, -offset_y];

    if(cap_round) {
        translate(point1) circle(d = width, $fn = 24);
        translate(point2) circle(d = width, $fn = 24);
    }

    polygon(points=[
        point1 + offset1, point2 + offset1,  
        point2 + offset2, point1 + offset2
    ]);
}

module polyline(points, width = 1) {
    module polyline_inner(points, index) {
        if(index < len(points)) {
            line(points[index - 1], points[index], width);
            polyline_inner(points, index + 1);
        }
    }

    polyline_inner(points, 1);
}




