use <openscad\idler_mount_z.scad>
use <openscad\rods_8mm.scad>
use <openscad\belt_z.scad>

$vpt = [56, -62, 54];
$vpr = [69, 0, 209];
$vpd =1280;

z_axis(0,0,0,1,150,100);


module z_axis(x,y,z,sk,d,z_pos)
{
    translate([x,y,z])
    {
        mirror([0,1,0])
        belt_z(0,-50,300);
        z_axis_parts(sk,d,z_pos);
        mirror([1,0,0])
        z_axis_parts(sk,d,z_pos);


        translate([0,-34.5-40,285])
        {
            color([0,0.8,0])
            rotate(a=90,v=[0,0,1])
            rotate(a=180,v=[1,0,0])
            import("stl//printable//nema_stronger_z.stl");
            color([0.2,0.2,0.2])
            translate([-4,5,-2])
            import("stl//nonprintable//Nema17.stl");
            color([0,0.8,0])
            translate([-3,-16,-35])
            scale([3.3,2,3.3])
            rotate(a=90,v=[1,0,0])
            import("stl//printable//logo_25x25.stl");
            color("lightgray")
            translate([0,5,4])
            import("stl//nonprintable//GT2_16T_Pulley.stl");
        }
        color("lightgray")
        rotate(a=-90,v=[0,1,0])
        rotate(a=90,v=[1,0,0])
        rods_8mm(2*d+50,400,-110,0,-18);
        
        //color("lightgray")
       /* rotate(a=-90,v=[0,1,0])
        rotate(a=90,v=[1,0,0])
        rods_8mm(2*d+0,300,5,0,-18);*/
        
        if(sk)
        color("lightgray")
        rotate(a=90,v=[1,0,0])
        rods_8mm(62,2*d+50,-(2*d+50)/2,0+z_pos,-48);
    }
}

module z_axis_parts(sk,dst,z_p)
{
    translate([-5-dst,18,0])
    {
        if(sk)
        {
            
            translate([-10,-10,z_p])
            rotate(a=180,v=[0,0,1])
            rotate(a=90,v=[1,0,0])
            {
                color([0.2,0.2,0.2])
                import("stl//printable//sk8_double_x_with_nut.stl");
                color([0,0.8,0])
                translate([10,25,10])
                rotate(a=-90,v=[1,0,0])
                {
                 
                    import("stl\\printable\\lmu815_154.stl");
                    translate([11,-17,12])
                    rotate(a=90,v=[0,0,1])
                    import("stl\\printable\\slip_ring_xy.stl");
                 }
                 
                color([0,0.8,0])
                translate([10,25-50,10])
                rotate(a=-90,v=[1,0,0])
                {
                
                    import("stl\\printable\\lmu815_154.stl");
                    translate([11,-17,12-25])
                    rotate(a=90,v=[0,0,1])
                    import("stl\\printable\\slip_ring_xy.stl");
                 }   
             }         
        }
        
        translate([5,0,35+z_p])
        import("stl//nonprintable//nut_with_holes.stl");
        
        color("lightgray")
        translate([5,0,304])
        rotate(a=180, v=[1,0,0])
        rotate(a=-90, v=[0,1,0])
        
        import("stl//nonprintable//gt2_6mm_36tooth_8bore.stl");
        
        color([0,0.8,0])
        {
            import("stl//printable//bearing_lower_z.stl");
            translate([0,0,-100])
            import("stl//printable//rod_mount_lower.stl");
            translate([0,0,275])
            import("stl//printable//bearing_upper_z.stl");
        }
        
            color("lightgray")
            difference()
            {
                translate([5,0,8-4])
                cylinder(r=11.025,h=9);
                translate([5,0,7-4])
                cylinder(r=4.15,h=15+0);
            }
            color("lightgray")
            difference()
            {
                translate([5,0,8+271])
                cylinder(r=11.025,h=9);
                translate([5,0,7+271])
                cylinder(r=4.15,h=15+0);
            }
        translate([+dst-35,-40,290])
        mirror([1,0,0])
        rotate(a=90,v=[0,0,1])
        idler_mount_z(0,0,0,1,1);
             
        color("lightgray")
        translate([9,0,150])
        import("stl//nonprintable//T8L300.stl");    
    }
}
